Page MenuHomePhabricator

[clang][DebugInfo] Allow function-local type-like entities to be scoped within a lexical block (5/5)
AcceptedPublic

Authored by krisb on May 16 2022, 8:44 AM.

Details

Summary

This is a part from D113743 split to make it easier to test and review.

It also enables lexical blocks as a scope for types and type-like entities
only if -debugger-tunning=gdb. lldb can't (yet) handle lexical block scoped
types (see D115277 for details), other debuggers were not verified (yet).

Diff Detail

Event Timeline

krisb created this revision.May 16 2022, 8:44 AM
Herald added a project: Restricted Project. · View Herald TranscriptMay 16 2022, 8:44 AM
krisb requested review of this revision.May 16 2022, 8:44 AM
Herald added a project: Restricted Project. · View Herald TranscriptMay 16 2022, 8:44 AM
Herald added a subscriber: cfe-commits. · View Herald Transcript
aprantl accepted this revision.May 26 2022, 6:10 PM

Sgtm.

This revision is now accepted and ready to land.May 26 2022, 6:10 PM
dblaikie added inline comments.May 27 2022, 1:27 PM
clang/lib/CodeGen/CGDebugInfo.cpp
231–234

Rather than doing an extra lookup in the assert, could probably check the return value of insert instead and assert based on that?

krisb updated this revision to Diff 434541.Mon, Jun 6, 11:10 AM
krisb marked an inline comment as done.

Applied review comments.